<template>
  <v-form @submit.prevent>
    <v-card-item>
      <h2 class="mb-4">Abteilung erstellen</h2>
      <p style="color: limegreen" v-if="createSuccess">Abteilung wurde erfolgreich erstellt.</p>
      <v-text-field
          v-model="department.departmentName"
          label="Abteilung"
          type="text"
          required
          variant="outlined"
          maxlength="255"
          autocomplete="department"/>
      <p v-show="createFailure" style="color: red">Du musst der neuen Abteilung einen Namen geben.</p>
      <v-btn type="submit" color="blue-darken-4" class="buttonStyle" @click="createDepartment">Erstellen</v-btn>
      <v-snackbar location="bottom end">
        Ein unbekannter Fehler ist aufgetreten. Bitte versuchen Sie es später erneut.
      </v-snackbar>
    </v-card-item>
  </v-form>
</template>

<script setup>
import {ref} from "vue";
import {router} from "@/router";
import {useDepartmentStore} from "@/stores/departmentStore";

const departmentStore = useDepartmentStore();
const createSuccess = ref(false);
const createFailure = ref(false);
const department = ref({
  departmentName: ""
});

async function createDepartment() {
  try {
    if (department.value.departmentName.length > 0) {
      await departmentStore.createDepartment(department.value);
      department.value.departmentName = "";
      createSuccess.value = true;
      createFailure.value = false;
      await departmentStore.getDepartments();
    } else {
      createFailure.value = true;
    }
  } catch (error) {
    if (error.response) {
      // The request was made and the server responded with a status code
      // that falls out of the range of 2xx
      if (error.response.status === 401) {
        console.log('Unauthorized', error);
        // Handle the unauthorized error here
      } else if (error.response.status === 409) {
        console.error('DB Conflict', error);
      }else if (error.response.status === 403) {
        console.log('Forbidden! only ADMINS are allowed to create accounts.', error)
      } else {
        console.error('HTTP error', error.response.status);
      }
    } else if (error.request) {
      // The request was made but no response was received
      console.error('No response received', error.request);
    } else {
      // Something happened in setting up the request that triggered an Error
      console.error('Error', error.message);
    }
  }
}
</script>

<style scoped>
.buttonStyle{
  margin-left: 1.5%;
  margin-bottom: 9px;
  width: 97%;
}


</style>